TITLE ED ver. 1.01: libreta de apuntes 

.386
.model flat, stdcall

include C:\masm\include\windows.inc
include C:\masm\include\kernel32.inc
include C:\masm\include\user32.inc
include C:\masm\include\comdlg32.inc
include C:\masm\include\comctl32.inc
includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib comdlg32.lib
includelib comctl32.lib

WinMain PROTO :HINSTANCE, :HINSTANCE, :LPSTR, :SDWORD
WndProc PROTO :HWND, :UINT, :WPARAM, :LPARAM
AcercaDlgProc  PROTO :HWND, :LPSTR, :WPARAM, :LPARAM
   .const
 ; Win mesagges
        WM_MOVE         equ     0003
        WM_SETFOCUS     equ     0007

; Win Style        
        WS_THICKFRAME    EQU   00040000h       

; Edit window style
        ES_LEFT         equ     0000h
        ES_CENTER       equ     0001h
        ES_RIGHT        equ     0002h
        ES_MULTILINE    equ     0004h
        ES_UPPERCASE    equ     0008h
        ES_LOWERCASE    equ     0010h
        ES_PASSWORD     equ     0020h
        ES_AUTOVSCROLL  equ     0040h
        ES_AUTOHSCROLL  equ     0080h
        ES_NOHIDESEL    equ     0100h
        ES_OEMCONVERT   equ     0400h
        ES_READONLY     equ     0800h
        ES_WANTRETURN   equ     1000h
        ES_NUMBER       equ     2000h

        FILE_SHARE_READ equ     1
        FILE_SHARE_WRITE equ    2
        WM_GETTEXT      equ     0dh

IDI_ICON          equ      0010
IDM_MENU          equ      0011
IDM_NUEVO         equ      0100
IDM_ABRIR         equ      0101
IDM_GUARDAR       equ      0102
IDM_GUARDARCOMO   equ      0103
IDM_CERRAR        equ      0104
IDM_ENCONTRAR     equ      0105
IDM_ACERCA        equ      0106

TAMMAX            equ      260
TAMMEM            equ      65535
OUTPUTSIZE        equ      512

RGB macro red,green,blue
        xor eax,eax
        mov ah,blue
        shl eax,8
        mov ah,green
        mov al,red
endm

.data
cadFiltro       db "Archivos de texto(*.txt)",0,"*.txt",0
                db "Todos los archivos(*.*)",0,"*.*",0,0
nClase          db "cVentana",0
nClaseEdit      db "Richedit",0
nDLL		db 'riched32.dll',0
nVhijo          db "Ventana de edicin",0         
nArchivo        db "ED_1",0
idDialog        db "CuadroAcercaDe",0
buffer          db  TAMMAX dup(0)
ofn             OPENFILENAME <>
alto            dd  0
ancho           dd  0
cadSalida       db OUTPUTSIZE dup(0)
nAppCaption     LABEL  BYTE
czCadena1       db  "ED_1 "
czCadena2       db  255 dup(0)
pNombre         dd  0

Msg0		db 'El archivo ya existe, desea sobrescribirlo',0

        .data?
        hInstance HINSTANCE ?
	hLib HINSTANCE ?
        CommandLine LPSTR ?
        hEdit  HANDLE ?
        hMenu  HANDLE ?
        hArchivo HANDLE ?
        hMemoria HANDLE ?
        pMemoria DWORD ?
        TamArchivoEscrito DWORD ?
	lpFileSizeHigh DWORD ?
	FileSize DWORD ?

        .code
        start:
        INVOKE GetModuleHandle, NULL
        mov    hInstance,eax

; Obtener la lnea de comandos
        invoke GetCommandLine
        mov    CommandLine,eax         ; -> Linea de comandos - Command Line

        INVOKE WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

        INVOKE ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD
        
        LOCAL msg:MSG
        LOCAL hWndp:HWND
        LOCAL wc:WNDCLASSEX

	; Register a class for the main window
	; Registrar una clase para la ventana principal
       
        mov   wc.cbSize,SIZEOF WNDCLASSEX
        mov   wc.style, CS_HREDRAW or CS_VREDRAW
        mov   wc.lpfnWndProc, OFFSET WndProc
        mov   wc.cbClsExtra,NULL
        mov   wc.cbWndExtra,NULL
        push  hInstance
        pop   wc.hInstance
        mov   wc.hbrBackground,4
        mov   wc.lpszMenuName,IDM_MENU
        mov   wc.lpszClassName,OFFSET nClase
        INVOKE LoadIcon,hInstance,ADDR nArchivo 
        mov   wc.hIconSm,eax
        mov   wc.hIcon,eax
        INVOKE LoadCursor,NULL,IDC_ARROW
        mov   wc.hCursor,eax
        INVOKE RegisterClassEx,ADDR wc

	; Get the menu handle
	; Obtener el manejador del men

        INVOKE   LoadMenu,hInstance,IDM_MENU 
        mov   hMenu,eax

	; Create the main window
	; Crear la ventana principal
        
        INVOKE CreateWindowEx,NULL,ADDR nClase,ADDR nAppCaption,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,0,hMenu,hInst,NULL
        mov   hWndp,eax
	cmp   eax,0
	je    get_out    

	; Show the main window
	; Mostrar la ventana principal

        INVOKE ShowWindow,hWndp,CmdShow
        INVOKE UpdateWindow,hWndp

	; Main window message dispatcher
	; Despachador de mensajes de la ventana principal

        .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
        .ENDW
get_out:
		; Free RICHED32.DLL
		; Liberar RICHED32.DLL
      invoke FreeLibrary,hLib                	

        mov     eax,msg.wParam
        ret
WinMain endp

WndProc proc hWndP:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        LOCAL rec:RECT
        
   mov   eax,uMsg

   .IF eax==WM_DESTROY
		; Advice that the program will return to Windows
		; Avisar que la aplicacin debe volver a Windows
      invoke PostQuitMessage,NULL
   
   .ELSEIF eax==WM_CREATE
		; Create the edit window
		; Crear la ventana de edicin
		; ===========================
	INVOKE LoadLibrary,ADDR nDLL ; Load Riched32.dll - Cargar Riched32.dll
		mov hLib,eax
                INVOKE CreateWindowEx,NULL,ADDR nClaseEdit,NULL,\
            WS_CHILD or WS_VISIBLE or WS_VSCROLL or\
            WS_BORDER or WS_THICKFRAME or ES_AUTOVSCROLL or\
            ES_MULTILINE,0,0,0,0,hWndP,1,hInstance,NULL
            mov  hEdit,eax
		; Grey background
		; Fondo gris
		INVOKE SendMessage,hEdit,EM_SETBKGNDCOLOR,0,0999999h

		; Initialize the OPENFILENAME structure
		; Inicializar la estructura OPENFILENAME
		; ======================================
            mov  ofn.Flags, OFN_FILEMUSTEXIST or \
                 OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
                 OFN_EXPLORER or OFN_HIDEREADONLY
            mov ofn.lStructSize,SIZEOF ofn
            push hWndP
            pop  ofn.hWndOwner
            push hInstance
            pop  ofn.hInstance
            mov  ofn.lpstrFilter, OFFSET cadFiltro
            mov  ofn.lpstrFile, OFFSET buffer
            mov  ofn.nMaxFile,TAMMAX            

   .ELSEIF eax==WM_SIZE
	    ; Set the edit window  
            ; Hacer que la ventana de edicin cambie de tamao con la ventana principal
	    ; ========================================================================
            invoke GetClientRect,hWndP,ADDR rec  ; Obtener coordenadas del a. cliente
            invoke MoveWindow,hEdit,0,0,rec.right,rec.bottom,TRUE ; asignar coordenadas al ctrl e ed.        

   .ELSEIF eax==WM_SETFOCUS
	    ; Focus the edit window
            ; Enfocar la ventana de edicin
	    ; =============================
                  INVOKE SetFocus,hEdit

   .ELSEIF eax==WM_COMMAND
	    ; Process the menu messages
            ; Procesar los mensajes del men
	    ; ==============================
                  mov     eax,wParam      
                .IF ax==IDM_CERRAR
                        invoke DestroyWindow,hWndP

                .ELSEIF ax==IDM_NUEVO
                        INVOKE SetWindowText,hEdit,NULL
                  mov byte ptr [buffer],0

                .ELSEIF ax==IDM_ABRIR
		; Open a file
		; Abrir un archivo
			; Select the file
			; Seleccionar el archivo
			; ======================
                        invoke GetOpenFileNameA,ADDR ofn
                        .if eax==TRUE
			; Open the file
			; Abrir el archivo
			; ================
                        invoke CreateFile,ADDR buffer,\
                           GENERIC_READ or GENERIC_WRITE ,\
                              FILE_SHARE_READ or FILE_SHARE_WRITE,\
                              NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,\
                              NULL
                        mov hArchivo,eax
			; Get the file size
                        ; Obtener el tamao del archivo
			; =============================
			invoke GetFileSize,eax,lpFileSizeHigh
			mov FileSize,eax
			; Commit virtual memory to read the opened file
			; Comprometer memoria virtual para leer el archivo
			; ================================================
			invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE			
                        mov  pMemoria,eax
			; Read the file
			; Leer el archivo
			; ===============
                        invoke ReadFile,hArchivo,eax,FileSize,\
                           ADDR TamArchivoEscrito,NULL
			; Set the text of the file in the edit window
			; Poner el texto del archivo en la ventana de edicin
			; ===================================================
                        invoke SendMessage,hEdit,WM_SETTEXT,NULL,pMemoria
			; Close the file and free commited memory
			; Cerrar el archivo y liberar memoria comprometida
			; ================================================
                        invoke CloseHandle,hArchivo
                        invoke VirtualFree,pMemoria,0,MEM_RELEASE
                        invoke SetFocus,hEdit
                        .endif
                        invoke SetFocus,hEdit

                .ELSEIF ax==IDM_GUARDAR
		  mov al,byte ptr [buffer]
		  cmp al,0
		  jne  created
		  guardar_como:
		  mov ofn.Flags,OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
                  invoke GetSaveFileName,ADDR ofn
                       cmp eax,0
		       je no_mapped
			  ; Open the file to write
			  ; Abrir el archivo a escribir
			  ; ===========================
		      mov eax,CREATE_NEW
		      createit:
                      invoke CreateFile,ADDR buffer,\
                           GENERIC_READ or GENERIC_WRITE ,\
                              FILE_SHARE_READ or FILE_SHARE_WRITE,\
                              NULL,eax,FILE_ATTRIBUTE_ARCHIVE,\
                              NULL
			cmp eax,-1
		        jne created
		      invoke MessageBox,hWndP,addr Msg0,addr nArchivo, MB_YESNO	or MB_ICONWARNING
			cmp eax,IDYES
			jne no_mapped
			mov eax,CREATE_ALWAYS
			jmp createit	
			  ; Get the number of bytes to write
			  ; Obtener el nmero de bytes a escribir
			  ; =====================================
			created:
                        mov hArchivo,eax
                        invoke SendMessage,hEdit,WM_GETTEXTLENGTH,0,0
			mov FileSize,eax
			  ; Map the file
			  ; Proyectar el archivo
			  ; ====================

				; Create a FileMapping Objetc
				; Crear un objeto de proyeccin de archivo
				; ========================================
			invoke CreateFileMapping,hArchivo,0,PAGE_READWRITE,0,eax,addr buffer
				cmp eax,0
				je no_mapped
				mov pMemoria,eax

				; Close the file
				; Cerrar el archivo
				; =================
			invoke CloseHandle,hArchivo

				; Map a view of file
				; Proyectar una vista del archivo
				; ===============================
			invoke MapViewOfFile,pMemoria,6,0,0,FileSize
				mov hArchivo,eax

				; Close the FileMapping object
				; Cerrar el objeto de proyeccin
				; ==============================
			invoke CloseHandle,edi

				; Write the file
				; Escribir el archivo
				; ===================
				cmp hArchivo,0
				jne  mapped
			invoke DeleteFile,ADDR buffer
				jmp no_mapped
			mapped:
			invoke SendMessage,hEdit,WM_GETTEXT,FileSize,hArchivo

				; Free the view of file
				; Liberar la vista proyectada
			invoke UnmapViewOfFile,hArchivo
		no_mapped:                      
			invoke SetFocus,hEdit

	       .ELSEIF ax==IDM_GUARDARCOMO
			jmp guardar_como
                                                                               
               .ELSEIF ax==IDM_ACERCA 
                INVOKE DialogBoxParam,hInstance,OFFSET idDialog,hWndP,\
                   ADDR AcercaDlgProc,NULL

               .ENDIF

        .ELSEIF eax==WM_CLOSE
		; Destroy the main window and close the program
		; Destruir la ventana principal y cerrar el programa
		invoke DestroyWindow,hWndP        
        .ELSE        
            INVOKE DefWindowProc,hWndP,uMsg,wParam,lParam
                  ret
        .ENDIF
	xor eax,eax
        ret
WndProc endp
   
AcercaDlgProc proc hDlg:HWND, iMsg:UINT, wParam:WPARAM, lParam:LPARAM
         mov eax,iMsg
         .IF eax==WM_INITDIALOG
         mov eax,1
         .ELSEIF eax==WM_COMMAND
            mov eax,wParam
            .if ax==IDOK
		; Close the ABOUT dialog box
		; Cerrar el dilogo ABOUT
               invoke EndDialog,hDlg,0
               mov eax,1
            .endif
         .ELSE
            xor eax,eax
         .ENDIF
            ret
AcercaDlgProc endp
            end   start 

